/*!
* Copyright (c) 2020 The Nuinalp Authors. All rights reserved.
* Use of this source code is governed by a BSD-style license that can be
* found in the LICENSE file.
*/
/* stylelint-disable selector-no-qualifying-type */
@import '../../style/utils/animations';

input[type='text'],
input[type='password'],
input[type='email'],
input[type='file'],
textarea {
  border: 0;
  border-color: transparent;
  font-family: 'FiraGO Regular';
  outline: 0;
  padding: $space-default;
  z-index: 4;
  font-size: 14px;
}

* {
  box-sizing: border-box;
}

:host {
  --border-radius: 4px;
  --border-bottom-width: 2px;
  --background-color: var(--nv-theme-primary);
  --border-bottom-style: var(--border-bottom-style);

  cursor: text;
  display: inline-block;
  vertical-align: top;
}

input {
  background-color: transparent;
  border: 0;
  height: 40px;
  padding: #{$space-sm} #{$space-default} !important;
  width: 100%;
}

textarea {
  background-color: transparent;
  width: 100%;
}

.nv-text-field-elements {  
  background-color: var(--nv-theme-alt-2);
  border-bottom-color: var(--nv-border-color);
  border-bottom-style: solid;
  border-bottom-width: var(--border-bottom-width);
  border-radius: var(--border-radius);
  display: flex;
  position: relative;
  width: 100%;
}

:host(.nv-text-field-password) {
  input {
    padding-right: 8px !important;
    width: calc(100% - 56px);
  }
}

.nv-text-field-prefix {
  @extend .transition-exit;
  color: var(--nv-type-secondary);
  line-height: 26px;
  opacity: 0;
  padding: #{$space-sm} $space-default;
  padding-right: 0 !important;
  visibility: hidden;
  z-index: 4;

  ~ input {
    padding-left: #{$space-sm} !important;
  }
}

.nv-text-field-suffix {
  @extend .transition-exit;
  color: var(--nv-type-secondary);
  line-height: 26px;
  opacity: 0;
  padding: #{$space-sm} $space-default;
  padding-left: 0;
  visibility: hidden;
  z-index: 4;

  ~ input {
    padding-right: #{$space-sm} !important;
  }
}

:host(.nv-text-field-display-prefix-sufix) {
  .nv-text-field-prefix,
  .nv-text-field-suffix {
    @extend .transition-entrance;
    opacity: 1;
    transition-delay: 250ms;
    visibility: visible;
  }
}

:host(.nv-txt-field-w-suffix) {
  input {
    padding-right: #{$space-sm} !important;
  }
}

:host(.nv-txt-field-disabled) {
  * {
    cursor: not-allowed;
  }

  cursor: not-allowed;
  opacity: 0.55;
}

.nv-text-field-container {
  display: flex;
  position: relative;


  //
  // Before
  //

  &::before {
    @extend .transition-moviment;
    background-color: var(--nv-theme-primary);
    border-radius: 4px;
    content: '';
    height: 100%;
    opacity: 0;
    pointer-events: none;
    position: absolute;
    top: 0;
    width: 100%;
    z-index: 4;
  }

  // 
  // Hover
  //

  &:hover::before {
    opacity: 0.05;
  }
}

.nv-text-field-helper-line {
  align-items: center;
  display: flex;
  justify-content: space-between;
  padding: 2px $space-default;
}

.nv-text-field-helper-line {
  align-items: center;
  display: flex;
  justify-content: space-between;
  padding: 2px $space-default;
}

.nv-txtfield-pass-view-btn {
  --width: 36px;
  --height: 36px;

  cursor: pointer;
  position: absolute;
  right: $space-default;
  top: calc(50% + 2px);
  transform: translateY(-50%);
  z-index: 4;

  svg,
  svg path {
    color: var(--nv-type-secondary);
    fill: var(--nv-type-secondary);
  }

  svg {
    width: 28px;
  }
}

//
// Focus
//

:host(.nv-text-field-focus) .nv-text-field-container::before {
  opacity: 0.1;
}

//
// Dense style
//

:host(.nv-text-field-dense) input {
  padding: $space-sm !important;
}

//
// Naked style
//

:host(.nv-text-field-naked) {
  ::before {
    display: none;
  }

  input[type='text'],
  input[type='password'],
  input[type='email'],
  input[type='file'],
  textarea {
    background-color: transparent;
  }

  .nv-text-field-elements {
    background-color: transparent !important;
    border-color: transparent;
  }

  .nv-text-field-ripple-focus {
    display: none !important;
  }
}

.nv-txt-field-label-active {
  > div span {
    @extend .transition-exit;
    top: 0%;
    transform: translateY(-100%) !important;
    transition-delay: 0ms !important;
  }
    
  > div {
    display: block;
    overflow: hidden;
    position: relative;
  }

  .label-fx {
    @extend .transition-entrance;
    top: -18px !important;
    transition-delay: 350ms;
  }
  
  // span {
  //   color: var(--nv-type-secondary);
  //   display: block;
  //   font-family: 'FiraGO Light Italic';
  //   font-size: 12px;
  //   line-height: 16px;
  //   padding: 2px $space-default;
    
  //   &.active {
  //     @extend .transition-entrance;
  //     transform: translateY(0%);
  //     transition-delay: 0.08s;
  //   }
  // }
}

//
// Label
//

.nv-txt-field-label,
.nv-select-selected-value {
  display: block;
  height: 42px;
  padding-right: 16px;
  position: relative;
  text-overflow: ellipsis;
  white-space: nowrap;
  width: 100%;

  > div {
    height: 100%;
    left: 0;
    overflow: hidden;
    position: absolute;
    top: 0;
    width: 100%;

    span {
      transition-delay: 350ms;
    }
  }
  
  span {
    @extend .transition-entrance;
    left: 0;
    padding-left: 16px;
    position: absolute;
    top: 50%;
    transform: translateY(-50%);
    width: 100%;
    z-index: 2;
  }

  .label-fx {
    @extend .transition-exit;
    font-size: 12px;
    top: 0;
    transform: unset;
    z-index: 1;
  }

  // Remove text select color
  &::selection {
    background-color: transparent;
  }
}

.nv-select-selected-value {
  transform: translateY(8px);
}

.nv-txt-field-label {
  @extend .transition-entrance;
  color: var(--nv-type-secondary);
  font-family: 'FiraGO Italic';
  left: 0;
  padding-left: $space-default;
  position: absolute;
  top: 0;

  &::before {
    background-color: var(--nv-theme-alt-2);
    border-top-left-radius: 4px;
    border-top-right-radius: 4px;
    content: '';
    height: 18px;
    left: 0;
    position: absolute;
    top: 0;
    width: 100%;
    z-index: 2;
  }
}

:host(.nv-text-field-with-label) {
  margin-top: $space-default;
}

.nv-text-field-counter {
  margin-left: $space-default;
}

.nv-text-field-helper-text,
.nv-text-field-error-text {
  font-size: 12px;
  line-height: 16px;
  padding: $space-sm 0;

  &:empty {
    display: none;
  }
}

.nv-text-field-error-text {
  color: var(--nv-theme-danger);
}
